Assignment 5 - BST Earthquake Data
==================================

Goals
-----

The purpose of this assignment is to learn to

1. Use (near) real-time collected earthquake data with a binary search tree.
2. Insert earthquake data into the nodes of a binary search tree, keyed on quake magnitude.
3. Highlight quakes by ranges and traversal algorithms in the BST

You will generate a visualization that looks like [that](http://bridges-cs.herokuapp.com/assignments/5/bridges_workshop)!

Programming part
----------------

### Task

Highlight the shortest path between two actors in a Movie Actor graph.

### Getting Started

1. Open your scaffolded code.
2. Plug in your credentials.
3. Retrieve the earthquake data (start with a few hundred), then visualize.
4. Filter them to take out the smallest quakes, visualize.
5. Look at `BST` file. Write a simple recursive algorithm to find and highlight quakes by their magnitudes.
6. Optional exercises: additional algorithms, mark the insertion/find path in a BST, scale
	node size by magnitude, etc.


### Help

#### for Java

[List Documentation](https://docs.oracle.com/javase/8/docs/api/java/util/List.html)

[BSTElement documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1base_1_1_b_s_t_element.html)

[Element documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1base_1_1_element.html)

[ElementVisualizer documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1base_1_1_element_visualizer.html)

[LinkVisualizer documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1base_1_1_link_visualizer.html)

[EarthquakeUSGS documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1data__src__dependent_1_1_earthquake_u_s_g_s.html )


#### for C++

[std::vector documentation](http://www.cplusplus.com/reference/vector/vector/)


[Element documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_element.html)

[BSTElement documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_b_s_t_element.html)

[ElementVisualizer documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_element_visualizer.html)

[LinkVisualizer documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_link_visualizer.html)

[EarthquakeUSGS documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_earthquake_u_s_g_s.html)
