/* Import Bridges and relevant data source */
import bridges.connect.Bridges;
import bridges.data_src_dependent.Shakespeare;

import java.util.List;
import java.util.HashMap;
import java.util.Map;

public class PQBook {

  public static String[] splitLyrics(String lyrics) {       // splits raw lyrics string into a parsable array
    lyrics = lyrics.replaceAll("\\[.+\\]", "");        // removes the titles of song stage ex [Intro]
    lyrics = lyrics.trim();
    String[] lyricsSplit = lyrics.split("\\s+");

    for (int i = 0; i < lyricsSplit.length; i++) {          // clears special characters from individual terms
      lyricsSplit[i] = lyricsSplit[i].replaceAll("\\W+$", "");
      lyricsSplit[i] = lyricsSplit[i].replaceAll("^\\W+", "");
      lyricsSplit[i] = lyricsSplit[i].trim();
    }

    return lyricsSplit;
  }


  public static void main(String[] args) throws Exception {

    /* Initialize a Bridges connection with your credentials */
    Bridges bridges = new Bridges(8, "YOUR_USER_ID", "YOUR_API_KEY");

    /* Set an assignment title */
    bridges.setTitle("PQBook");

    List<Shakespeare> shksp_list = (List<Shakespeare>) Bridges.getShakespeareData("poems", true);

    //Retain only the first text
    Shakespeare po1 = shksp_list.get(0);

    //System.out.println(po1.getText());

    // Tokenize
    String[] wordlist = splitLyrics(po1.getText());

    //for (int i=0; i<wordlist.length; ++i)
    //    System.out.println(wordlist[i]);


    HashMap<String, Integer> counts = new HashMap<String, Integer>();

    // build the count
    for (int i = 0; i < wordlist.length; ++i) {
      String wo = wordlist[i];

      Integer st = counts.get(wo);
      if (st == null)
        counts.put(wo, 1);
      else
        counts.put(wo, st + 1);
    }

    //
    for (Map.Entry<String, Integer> e : counts.entrySet()) {
      System.out.println(e.getKey() + " " + e.getValue());
    }

    //building the heap
    MyHeap<Integer, String> mh = new MyHeap<Integer, String>();

    for (Map.Entry<String, Integer> e : counts.entrySet()) {
      mh.insert(e.getValue(), e.getKey());
    }

    mh.updateLabels();

    /* Pass the data structure to Bridges */
    bridges.setDataStructure(mh.root);

    /* Visualize the list */
    bridges.visualize();

    while (mh.size() > 10) {
      mh.pop();
    }

    mh.updateLabels();


    /* Pass the data structure to Bridges */
    bridges.setDataStructure(mh.root);

    /* Visualize the list */
    bridges.visualize();
  }
}
